/// \file FixedOrderGenerator.cc This file is generated automatically by writecpp.py.\n
/// It contains the code for fixed order n<=3 splitting of a quark or gluon.\n
/// For initial quark use split_quarkN() for Nth order splitting.\n
/// For initial gluon use split_gluonN() for Nth order splitting.\n
#include "FixedOrderGenerator.hh"

const double FixedOrderGenerator::_eps = 1e-10;

void FixedOrderGenerator::split_quark1() {
  /// Code generated automatically by writecpp.py using functional/quark_order1.dat.
  double weight[1];
  double z=_rng.uniform();
  double pqq_z=pqq(z);
  weight[0]=pqq_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(1,Parton::q));
  _events.push_back(Event(state,(-1)*weight[0]));
}
void FixedOrderGenerator::split_gluon1() {
  /// Code generated automatically by writecpp.py using functional/gluon_order1.dat.
  double weight[2];
  double z=_rng.uniform();
  double pqg_z=pqg(z), pgg_z=pgg(z);
  weight[0]=pgg_z;
  weight[1]=pqg_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
}
void FixedOrderGenerator::split_quark2() {
  /// Code generated automatically by writecpp.py using functional/quark_order2.dat.
  double weight[3];
  double z=_rng.uniform();
  double pqq_z=pqq(z);
  double zp=_rng.uniform();
  double pqq_zp=pqq(zp), pqg_zp=pqg(zp), pgg_zp=pgg(zp);
  weight[0]=pqq_zp*pqq_z;
  weight[1]=pgg_zp*pqq_z;
  weight[2]=pqg_zp*pqq_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(1,Parton::q));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
}
void FixedOrderGenerator::split_gluon2() {
  /// Code generated automatically by writecpp.py using functional/gluon_order2.dat.
  double weight[5];
  double z=_rng.uniform();
  double pqg_z=pqg(z), pgg_z=pgg(z);
  double zp=_rng.uniform();
  double pqq_zp=pqq(zp), pqg_zp=pqg(zp), pgg_zp=pgg(zp);
  weight[4]=pqg_zp*pqg_z;
  weight[2]=pqq_zp*pqg_z;
  weight[0]=pgg_zp*pgg_z;
  weight[3]=pgg_zp*pqg_z;
  weight[1]=pqg_zp*pgg_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
}
void FixedOrderGenerator::split_quark3() {
  /// Code generated automatically by writecpp.py using functional/quark_order3.dat.
  double weight[9];
  double z=_rng.uniform();
  double pqq_z=pqq(z);
  double zp=_rng.uniform();
  double pqq_zp=pqq(zp), pqg_zp=pqg(zp), pgg_zp=pgg(zp);
  double zpp=_rng.uniform();
  double pqq_zpp=pqq(zpp), pqg_zpp=pqg(zpp), pgg_zpp=pgg(zpp);
  weight[5]=pqg_zpp*pgg_zp*pqq_z;
  weight[7]=pgg_zpp*pqg_zp*pqq_z;
  weight[0]=pgg_zpp*pqq_zp*pqq_z;
  weight[4]=pgg_zpp*pgg_zp*pqq_z;
  weight[1]=pqg_zpp*pqq_zp*pqq_z;
  weight[8]=pqg_zpp*pqg_zp*pqq_z;
  weight[6]=pqq_zpp*pqg_zp*pqq_z;
  weight[2]=pqq_zpp*pqq_zp*pqq_z;
  weight[3]=pqq_zpp*pgg_zp*pqq_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::g));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::q));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton(z*zp*zpp,Parton::q));
  state.push_back(Parton(z*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::g));
  state.push_back(Parton(zp*zpp,Parton::q));
  state.push_back(Parton(zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(zpp,Parton::q));
  state.push_back(Parton((1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(1,Parton::q));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zp*zpp,Parton::g));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zp*zpp,Parton::q));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  state.push_back(Parton((1-z)*zp*zpp,Parton::q));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[7]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[7]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[8]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[8]));
}
void FixedOrderGenerator::split_gluon3() {
  /// Code generated automatically by writecpp.py using functional/gluon_order3.dat.
  double weight[13];
  double z=_rng.uniform();
  double pqg_z=pqg(z), pgg_z=pgg(z);
  double zp=_rng.uniform();
  double pqq_zp=pqq(zp), pqg_zp=pqg(zp), pgg_zp=pgg(zp);
  double zpp=_rng.uniform();
  double pqq_zpp=pqq(zpp), pqg_zpp=pqg(zpp), pgg_zpp=pgg(zpp);
  weight[1]=pqg_zpp*pgg_zp*pgg_z;
  weight[11]=pgg_zpp*pqg_zp*pqg_z;
  weight[4]=pqq_zpp*pqg_zp*pgg_z;
  weight[9]=pqg_zpp*pgg_zp*pqg_z;
  weight[12]=pqg_zpp*pqg_zp*pqg_z;
  weight[7]=pqg_zpp*pqq_zp*pqg_z;
  weight[8]=pgg_zpp*pgg_zp*pqg_z;
  weight[3]=pqg_zpp*pqg_zp*pgg_z;
  weight[5]=pqq_zpp*pqq_zp*pqg_z;
  weight[10]=pqq_zpp*pqg_zp*pqg_z;
  weight[2]=pgg_zpp*pqg_zp*pgg_z;
  weight[0]=pgg_zpp*pgg_zp*pgg_z;
  weight[6]=pgg_zpp*pqq_zp*pqg_z;
  std::vector<Parton> state;
  state.clear();
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton(z*zp*zpp,Parton::g));
  state.push_back(Parton(z*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::g));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zp*zpp,Parton::g));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::g));
  state.push_back(Parton(zp*zpp,Parton::g));
  state.push_back(Parton(zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(zpp,Parton::g));
  state.push_back(Parton((1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[0]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[0]));
  state.clear();
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton(z*zp*zpp,Parton::q));
  state.push_back(Parton(z*zp*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::q));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zp*zpp,Parton::q));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::g));
  state.push_back(Parton(zp*zpp,Parton::q));
  state.push_back(Parton(zp*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(zpp,Parton::q));
  state.push_back(Parton((1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[1]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[1]));
  state.clear();
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::g));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(zpp,Parton::g));
  state.push_back(Parton((1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[2]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[2]));
  state.clear();
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z),Parton::g));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(zpp,Parton::q));
  state.push_back(Parton((1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[3]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[3]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*(1-zp),Parton::q));
  state.push_back(Parton(z*zp*zpp,Parton::q));
  state.push_back(Parton(z*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::q));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton((1-z),Parton::g));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  state.push_back(Parton((1-z)*zp*zpp,Parton::q));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z,Parton::g));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::q));
  state.push_back(Parton(zp*zpp,Parton::q));
  state.push_back(Parton(zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[4]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[4]));
  state.clear();
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  state.push_back(Parton(z*zp*zpp,Parton::q));
  state.push_back(Parton(z*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  state.push_back(Parton((1-z)*zp*zpp,Parton::q));
  state.push_back(Parton((1-z)*zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zpp,Parton::q));
  state.push_back(Parton(z*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[5]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z),Parton::q));
  _events.push_back(Event(state,(1)*weight[5]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::g));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[6]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[6]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp)*zpp,Parton::q));
  state.push_back(Parton(z*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[7]));
  state.clear();
  state.push_back(Parton((1-z),Parton::q));
  state.push_back(Parton(z*zp,Parton::q));
  state.push_back(Parton(z*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[7]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[7]));
  state.clear();
  state.push_back(Parton(z,Parton::q));
  state.push_back(Parton((1-z)*zp,Parton::q));
  state.push_back(Parton((1-z)*(1-zp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[7]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::g));
  state.push_back(Parton(zp*zpp,Parton::g));
  state.push_back(Parton(zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[8]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[8]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp)*zpp,Parton::g));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[8]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[8]));
  state.clear();
  state.push_back(Parton(zpp,Parton::g));
  state.push_back(Parton((1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[8]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[8]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::g));
  state.push_back(Parton(zp*zpp,Parton::q));
  state.push_back(Parton(zp*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[9]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[9]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::q));
  _events.push_back(Event(state,(-1)*weight[9]));
  state.clear();
  state.push_back(Parton(zp,Parton::g));
  state.push_back(Parton((1-zp),Parton::g));
  _events.push_back(Event(state,(1)*weight[9]));
  state.clear();
  state.push_back(Parton(zpp,Parton::q));
  state.push_back(Parton((1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[9]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[9]));
  state.clear();
  state.push_back(Parton((1-zp),Parton::q));
  state.push_back(Parton(zp*zpp,Parton::q));
  state.push_back(Parton(zp*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[10]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[10]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp)*zpp,Parton::q));
  state.push_back(Parton((1-zp)*(1-zpp),Parton::g));
  _events.push_back(Event(state,(-1)*weight[10]));
  state.clear();
  state.push_back(Parton(zp,Parton::q));
  state.push_back(Parton((1-zp),Parton::q));
  _events.push_back(Event(state,(1)*weight[10]));
  state.clear();
  state.push_back(Parton(zpp,Parton::g));
  state.push_back(Parton((1-zpp),Parton::g));
  _events.push_back(Event(state,(1)*weight[11]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[11]));
  state.clear();
  state.push_back(Parton(zpp,Parton::q));
  state.push_back(Parton((1-zpp),Parton::q));
  _events.push_back(Event(state,(1)*weight[12]));
  state.clear();
  state.push_back(Parton(1,Parton::g));
  _events.push_back(Event(state,(-1)*weight[12]));
}
void FixedOrderGenerator::split_quark4() {
  std::cout << "Invalid value for order" << std::endl;
  exit(-1);
}
void FixedOrderGenerator::split_gluon4() {
  std::cout << "Invalid value for order" << std::endl;
  exit(-1);
}
void FixedOrderGenerator::split_quark5() {
  std::cout << "Invalid value for order" << std::endl;
  exit(-1);
}
void FixedOrderGenerator::split_gluon5() {
  std::cout << "Invalid value for order" << std::endl;
  exit(-1);
}
